/** Rill v0.0.471 https://www.npmjs.com/package/rill License: MIT*/
var byteLength, empty, isType;

isType = require("./isType");

byteLength = require("./byteLength");

empty = {
  204: true,
  205: true,
  304: true
};


/*
 * A default middleware that handles sending the response for the request.
#
 * @param {Object} req
 * @param {Object} res
 * @param {Function} next
 */

module.exports = regeneratorRuntime.mark(function callee$0$0(req, res, next) {
  var body, headers, method, originalRes, redirect, status;

  return regeneratorRuntime.wrap(function callee$0$0$(context$1$0) {
    while (1) switch (context$1$0.prev = context$1$0.next) {
    case 0:
      context$1$0.next = 2;
      return next;
    case 2:
      method = req.method, redirect = req.redirect;
      originalRes = res.originalRes, headers = res.headers, status = res.status, body = res.body;

      if (!originalRes.headersSent) {
        context$1$0.next = 6;
        break;
      }

      return context$1$0.abrupt("return");
    case 6:
      if (redirect != null) {
        if (headers["Location"] == null) {
          headers["Location"] = redirect;
        }
      }
      if (Number(status) === 404 && (body != null)) {
        status = 200;
      }

      if (!(empty[status] || body == null)) {
        context$1$0.next = 13;
        break;
      }

      if (headers["Content-Type"] == null) {
        headers["Content-Type"] = void 0;
      }
      body = void 0;
      context$1$0.next = 26;
      break;
    case 13:
      if (!isType.String(body)) {
        context$1$0.next = 17;
        break;
      }

      if (headers["Content-Type"] == null) {
        headers["Content-Type"] = "text/" + (/^\s*</.test(body) ? "html" : "plain");
      }
      context$1$0.next = 26;
      break;
    case 17:
      if (!isType.Object(body)) {
        context$1$0.next = 22;
        break;
      }

      if (headers["Content-Type"] == null) {
        headers["Content-Type"] = "application/json";
      }
      body = JSON.stringify(body);
      context$1$0.next = 26;
      break;
    case 22:
      if (headers["Content-Type"] == null) {
        headers["Content-Type"] = "application/octet-stream";
      }
      if (body.length) {
        if (headers["Content-Length"] == null) {
          headers["Content-Length"] = body.length;
        }
      }

      if (!isType.Stream(body)) {
        context$1$0.next = 26;
        break;
      }

      return context$1$0.abrupt("return", body.pipe(originalRes));
    case 26:
      if (headers["Content-Length"] == null) {
        headers["Content-Length"] = byteLength(body);
      }
    case 27:
    case "end":
      return context$1$0.stop();
    }
  }, callee$0$0, this);
});
